dnl Assumes gethostbyname_r is already available in LIBS
dnl Based on AC_caolan_FUNC_WHICH_GETHOSTBYNAME_R by
dnl Caolan McNamara <caolan@skynet.ie>
AC_DEFUN(DV_FUNC_WHICH_GETHOSTBYNAME_R,[
AC_MSG_CHECKING([calling sequence of gethostbyname_r])
dv_func_which_gethostname_r_args=""
if test -z "$dv_func_which_gethostname_r_args"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <netdb.h> ]], [[
    char *name;
    struct hostent *he;
    struct hostent_data data;
    (void) gethostbyname_r(name, he, &data);
    ]])],[dv_func_which_gethostname_r_args=a3],[])
fi

if test -z "$dv_func_which_gethostname_r_args"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <netdb.h>]], [[
    char *name;
    struct hostent *he, *res;
    char buffer[2048];
    int buflen = 2048;
    int h_errnop;
    (void) gethostbyname_r(name, he, buffer, buflen, &res, &h_errnop)
    ]])],[dv_func_which_gethostname_r_args=a6],[])
fi

if test -z "$dv_func_which_gethostname_r_args"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <netdb.h>]], [[
    char *name;
    struct hostent *he;
    char buffer[2048];
    int buflen = 2048;
    int h_errnop;
    (void) gethostbyname_r(name, he, buffer, buflen, &h_errnop)
    ]])],[dv_func_which_gethostname_r_args=a5],[])
fi

if test -n "$dv_func_which_gethostname_r_args"; then
  AC_MSG_RESULT($dv_func_which_gethostname_r_args)
fi

if test "$dv_func_which_gethostname_r_args" = a6; then
  AC_DEFINE(HAVE_FUNC_GETHOSTBYNAME_R_6,[1],[Define as 1 if gethostbyname takes 6 arguments])
elif test "$dv_func_which_gethostname_r_args" = a5; then
  AC_DEFINE(HAVE_FUNC_GETHOSTBYNAME_R_5,[1],[Define as 1 if gethostbyname takes 5 arguments])
elif test "$dv_func_which_gethostname_r_args" = a3; then
  AC_DEFINE(HAVE_FUNC_GETHOSTBYNAME_R_3,[1],[Define as 1 if gethostbyname takes 3 arguments])
dnl else
dnl  AC_MSG_ERROR([unknown calling sequence])
fi
])

dnl Assumes gethostbyaddr_r is already available in LIBS
AC_DEFUN(DV_FUNC_WHICH_GETHOSTBYADDR_R,[
AC_MSG_CHECKING([calling sequence of gethostbyaddr_r])
dv_func_which_gethostaddr_r_args=""
if test -z "$dv_func_which_gethostaddr_r_args"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <netdb.h> ]], [[
    unsigned long addr;
    int addrsz,type;
    struct hostent *he, *res;
    char buffer[2048];
    int buflen = 2048;
    int h_errnop;
    (void) gethostbyaddr_r(&addr, addrsz, type, he, buffer, buflen, &res, &h_errnop)
    ]])],[dv_func_which_gethostaddr_r_args=a8],[])
fi

if test -z "$dv_func_which_gethostaddr_r_args"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <netdb.h>]], [[
    unsigned long addr;
    int addrsz,type;
    struct hostent *he;
    char buffer[2048];
    int buflen = 2048;
    int h_errnop;
    (void) gethostbyaddr_r((const char*)(&addr), addrsz, type, he, buffer, buflen, &h_errnop)
    ]])],[dv_func_which_gethostaddr_r_args=a7],[])
fi


if test -n "$dv_func_which_gethostaddr_r_args"; then
  AC_MSG_RESULT($dv_func_which_gethostaddr_r_args)
fi

if test "$dv_func_which_gethostaddr_r_args" = a8; then
  AC_DEFINE(HAVE_FUNC_GETHOSTBYADDR_R_8,[1],[Define as 1 if gethostbyaddr takes 8 arguments])
elif test "$dv_func_which_gethostaddr_r_args" = a7; then
  AC_DEFINE(HAVE_FUNC_GETHOSTBYADDR_R_7,[1],[Define as 1 if gethostbyaddr takes 7 arguments])
dnl else
dnl  AC_MSG_ERROR([unknown calling sequence])
fi
])

@AC_DEFUN(DV_HAVE_PUBSYNC,[
AC_MSG_CHECKING([ios::streambuf::pubsync or ios::streambuf::sync])
DV_PUBSYNC=""

AC_LANG_PUSH(C++)
if test -z "$DV_PUBSYNC"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iostream>]], [[
    std::cin.rdbuf()->pubsync();
    ]])],[DV_PUBSYNC="pubsync"],[])
fi

if test -z "$DV_PUBSYNC"; then
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <iostream>]], [[
    std::cin.rdbuf()->sync();
    ]])],[DV_PUBSYNC="sync"],[])
fi
AC_LANG_POP(C++)

if test -n "$DV_PUBSYNC"; then
  AC_MSG_RESULT($DV_PUBSYNC)
fi

if test -z "$DV_PUBSYNC"; then
  AC_MSG_ERROR([neither cin.rdbuf()->pubsync() nor cin.rdbuf()->sync() work])
fi

AC_DEFINE_UNQUOTED(STREAMBUF_PUBSYNC,[$DV_PUBSYNC],[streambuf::pubsync substitute])
])

