// $Id: test-fileserver-client.C,v 1.3 2002/10/18 18:15:37 dvermeir Exp $

#include <stdlib.h>	// atoi()
#include <iostream>
#include <iostream>
#include <fstream>
#include <string>
#include <stdexcept>

#include "socket.h"
#include "message.h"

// A simple 1-shot fileserver client

using namespace std;
using namespace Dv;
using namespace Net;

int
main(int argc, char* argv[] ) {
const char* usage = "techoc host port filename";
try {
  if (argc<4) 
    throw runtime_error(usage);

  Socket	client(argv[1],atoi(argv[2]),1024,10000);

  if (!client)
    throw runtime_error(client.strerror());

  const char* fn(argv[3]);

  cerr << "client: requested " << fn << endl;
  client << fn << endl;
  // The following could be done much shorter but we want to
  // test the Message<string>::operator string().
  // The shorter way:
  // ===
  // SimpleMessage m;
  // client >> m;
  // ofs.write(m.data(), m.size())
  // ===
  string f_contents;
  Message<string> m(f_contents);
  client >> m;
  string s(m);
  ofstream ofs(fn);
  if (ofs)
    ofs.write(s.data(), s.size());
  else
    throw runtime_error(string(fn) + ": cannot create");
  }
catch (exception& e) {
  cerr << "client: " <<  e.what() << endl;
  return 1;
  }
return 0;
}
