// $Id: test-fileserver.C,v 1.4 2003/10/31 14:36:17 dvermeir Exp $

#include	<stdlib.h> // atoi
#include	<iostream>
#include	<fstream>
#include	"serversocket.h"
#include	"message.h"

// A simple 1-shot fileserver.

using namespace std;
using namespace Dv;
using namespace Net;

int main( int argc , char* argv[] ) {
static const char* usage = "fileserver port";

if (argc!=2) {
  cerr << usage << endl;
  return 1;
  }

try {
  ServerSocket	server(atoi(argv[1]));

  Dv::Util::ref<Socket>	client(server.accept());

  cerr << "server: accept from " << client->host() 
       << ":" << client->port() << endl;
  string fn;

  if (getline(*client,fn)) {
    cerr << "server: request for file " << fn << endl;
    ifstream ifs(fn.c_str());
    Message<filebuf*> m(ifs.rdbuf());
    if (ifs) 
      *client << m;
    else
      cerr << "\"" << fn << "\": cannot open" << endl;
    }
  cerr << "server: client_status: " << client->strerror() << endl;
  }
catch (exception& e) {
  cerr << "server: " << e.what() << endl;
  return 2;
  }
return 0;
}
