// $Id: test-message.C,v 1.3 2003/03/04 17:48:34 dvermeir Exp $
#include <fstream>
#include <iostream>
#include "message.h"

struct A {
  int i;
  int j;
  bool operator==(const A& a) { return (i == a.i) && (j == a.j); }
  bool operator!=(const A& a) { return ! (*this == a); }
};

std::istream&
operator>>(std::istream& is, A& a) {
return is >> a.i >> a.j;
}

std::ostream&
operator<<(std::ostream& os, const A& a) {
return os << a.i << " " << a.j;
}

int
main() {
A a;
a.i = 5;
a.j = 6;
{
std::ofstream ofs("test-message.txt");
Dv::Net::Message<A> m(a);
m.send(ofs);
}
{
std::ifstream ifs("test-message.txt");
Dv::Net::Message<A> m;
m.receive(ifs);
A b(m);
if (a != b)
  return 1;
}
{
std::ifstream ifs("test-message.txt");
Dv::Net::Message<A> m;
ifs >> m;
A b(m);
if (a != b)
  return 1;
}
}
