// $Id: test-uechocs.C,v 1.1 2002/10/18 18:15:37 dvermeir Exp $

#include <unistd.h> // for fork(), sleep()
#include <sys/types.h> // wait()
#include <sys/wait.h> // wait()
#include <fstream>
#include <string>

#include <dvnet/usocket.h>
#include <dvnet/userversocket.h>

using namespace std;
using namespace Dv;
using namespace Net;


int // return 0 iff ok
echo_client(const string& server) {
cerr << "Client connecting to " << server << endl;

usocket	client(server,4000);

if (!client) {
  cerr	<< "connection failed: " << client.strerror() << endl;
  return 1;
  }

ifstream ifs("/etc/passwd");
if (!ifs) {
  cerr << "Cannot open /etc/passwd" << endl;
  return 1;
  }

string line;
string ifsline;
int	n(0);
while (getline(ifs,ifsline)) {
  client << ifsline << endl;
  getline(client,line);
  if (line!=ifsline) {
    cerr << "Client expected \"" << ifsline << "\", got \"" << line << "\"" << endl;
    return 1;
    }
  ++n;
  }
cout << "client read " << n << " lines" << endl;
cout << "client exit:" << client.strerror() << endl;
return client.error();
}

int
main(int argc,char* argv[]) {
// const char* const usage = "tuechocs";
const string servername("/tmp/tuechocs.sock");

int child = fork();

if (child<0) {
  cerr << "fork() failed" << endl;
  return 1;
  }
  
if (child==0) {
  sleep(3);
  cerr << "Starting client.." << endl;
  return echo_client(servername);
  }

try {
  userversocket	server(servername);
  cerr << "Starting server.." << endl;
  if (!server) {
    cerr << "Error creating server: " << server.strerror() << endl;
    return 2;
    }

  Dv::Util::ref<usocket> client(server.accept());

  cout << "Connection " << endl;

  string line;
  while (getline(*client,line))
    *client << line << endl;
  cout << "client: " << client->strerror() << endl;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 2;
  }

int client_status;
wait(&client_status);

if (WIFEXITED(client_status)) 
   if (WEXITSTATUS(client_status)==0)
     return 0;
   else
     return 1;
else
  return 1;
}
