// $Id: test-uprops.C,v 1.1 2002/10/18 18:15:37 dvermeir Exp $

#include <unistd.h> // for fork(), sleep()
#include <sys/types.h> // wait()
#include <sys/wait.h> // wait()
#include <fstream>
#include <string>
#include <dvutil/props.h>
#include <dvnet/usocket.h>
#include <dvnet/userversocket.h>

using namespace std;
using namespace Dv;
using namespace Net;


int // return 0 iff ok
props_client(const string& server) {
cerr << "Client connecting to " << server << endl;

usocket	client(server,4000);

if (!client) {
  cerr	<< "connection failed: " << client.strerror() << endl;
  return 1;
  }

Util::Props	myprops;
Util::env2props(myprops);

Util::Props	server_props;

server_props.receive(client);

if (server_props != myprops) {
  cerr << "client expected \n" << myprops << endl
       << "got\n" << server_props << endl;
  return 1;
  }

myprops.send(client);

cout << "client read " << server_props.size() << " properties" << endl;
cout << "client exit:" << client.strerror() << endl;
return client.error();
}

int
main(int argc,char* argv[]) {
// const char* const usage = "tuechocs";
const string servername("/tmp/tuechocs.sock");

int child = fork();

if (child<0) {
  cerr << "fork() failed" << endl;
  return 1;
  }
  
if (child==0) {
  sleep(3);
  cerr << "Starting client.." << endl;
  return props_client(servername);
  }

try {
  userversocket	server(servername);
  cerr << "Starting server.." << endl;
  if (!server) {
    cerr << server.strerror() << endl;
    return  2;
    }

  Dv::Util::ref<usocket>	client(server.accept());

  cout << "Connection " << endl;

  Util::Props	myprops;
  Util::env2props(myprops);

  myprops.send(*client);

  Util::Props	client_props;
  client_props.receive(*client);

  if (client_props!=myprops) 
    cerr << "server expected\n" << myprops 
         << "server got\n" << client_props
	 << endl;


  cout << "client: " << client->strerror() << endl;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 2;
  }

int client_status;
wait(&client_status);

if (WIFEXITED(client_status)) 
   if (WEXITSTATUS(client_status)==0)
     return 0;
   else
     return 1;
else
  return 1;
}
