// $Id: userversocket.C,v 1.5 2002/10/18 18:15:37 dvermeir Exp $

#include <string>
#include <errno.h>
#include <unistd.h> // close()
#include <sys/socket.h> // listen()
#include <dvutil/file.h> 
#include "usockstreambuf.h"
#include "userversocket.h"

using namespace std;

namespace Dv {
namespace Net {

userversocket::userversocket(const string& filename, time_t delay,
  int nconnections): fn_(filename), fd_(usockstreambuf::bind(filename,errno_)),
  delay_(delay)  {
static const string ERRMSG("userversocket::userversocket(");

if (errno_) {
  return; 
  // throw runtime_error(ERRMSG+filename+"): "+::strerror(errno_));
  }

if (::listen(fd_,nconnections)<0) {
  errno_ = errno;
  return;
  // throw runtime_error(ERRMSG+filename+"): "+::strerror(errno_));
  }
}

string
userversocket::strerror() const {
if (errno_)
  return ::strerror(errno_);
else
  return "OK";
}

userversocket::~userversocket() {
if (fd_)
  ::close(fd_);
try {
  Dv::Util::File	f(fn_);
  f.rm();
  }
catch (exception& e) {
  // ignore
  }
}

}}
