// $Id: usocksetup.C,v 1.2 2002/10/18 18:15:37 dvermeir Exp $
// $Log: usocksetup.C,v $
// Revision 1.2  2002/10/18 18:15:37  dvermeir
// Saving..
//
// Revision 1.1  2001/06/16 10:08:55  dvermeir
// Added unix socket classes.
//
#include "usocksetup.h"
#include <string.h> // memset

namespace Dv {
namespace Net {

void
setup_unsocket(const std::string& filename, sockaddr_un& unaddr, socklen_t& len)
  throw (std::runtime_error) {
/*
   from linux <sys/un.h>:

  struct sockaddr_un {
    __SOCKADDR_COMMON (sun_);
    char sun_path[108];	 // Path name.
    };
*/
static const std::string ERRMSG("Dv::Net::setup_unsocket(");

if (filename.size()>=108)
  throw std::runtime_error(ERRMSG+filename+"): name too long");

memset(&unaddr,0,sizeof(unaddr));
unaddr.sun_family = AF_UNIX;
strcpy(unaddr.sun_path,filename.c_str());
len = sizeof(sockaddr_un) - sizeof(unaddr.sun_path) + strlen(unaddr.sun_path)+1;
}

}}
