// $Id: usockstreambuf.C,v 1.3 2002/10/18 18:15:37 dvermeir Exp $
#include <config.h>


#include <string.h> // strcpy, strlen, ::strerror()
#include <errno.h> // ::errno
#include <stdlib.h> // size_t
#include <unistd.h> // unlink
#include <sys/types.h> // ::bind()

#include "usockstreambuf.h"
#include "usocksetup.h"

using namespace std;

namespace Dv {
namespace Net {

usockstreambuf::usockstreambuf(size_t in_buf_size, size_t out_buf_size,
  time_t millisecs): fdstreambuf(-1,in_buf_size,out_buf_size,millisecs), fn_() {
}

usockstreambuf::~usockstreambuf() {
close(); // fdstreambuf::close
}

int
usockstreambuf::bind(const string& filename, int& err) {
err = 0;
sockaddr_un  addr;
socklen_t    len;

int sfd = socket(AF_UNIX,SOCK_STREAM,0);
if (sfd<0) {
  err = errno;
  return -1;
  }

::unlink(filename.c_str());

setup_unsocket(filename,addr,len);
if (::bind(sfd, reinterpret_cast<sockaddr*>(&addr), len)<0) { // bind fd to name
  err = errno;
  return -1;
  }
return sfd;
}

}}
